#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

//note to self: invaluable information about hStdOutput at http://www.bolekvrany.cz/index.php?lang=en&what=articles&subsection=control_another_app

#define PROGRAM_NO_OUTPUT 0
#define PROGRAM_GAVE_OUTPUT 1
#define PROGRAM_CRASHED 2
#define PROGRAM_TIMED_OUT 3

int chrfromhex(char c)
{
#define r(a, b) if (c==a) return b;
	r('0', 0); r('1', 1); r('2', 2); r('3', 3); r('4', 4); r('5', 5); r('6', 6); r('7', 7); r('8', 8); r('9', 9);
	r('a', 10); r('b', 11); r('c', 12); r('d', 13); r('e', 14); r('f', 15);
	r('A', 10); r('B', 11); r('C', 12); r('D', 13); r('E', 14); r('F', 15);
#undef r
	return -1;
}

#define error(str) fail=str
#define errorf(...) do { sprintf(theerrorstr, __VA_ARGS__); error(theerrorstr); } while(0)
int main(int argc, char * argv[])
{
	char theerrorstr[1024];
	if (argc!=2)
	{
		printf("usage: xkastest xkas.exe");
		return 1;
	}
	int failed=0;
	int failedopt=0;
	int total=0;
	int totalopt=0;
	FILE * thetests=fopen("thetests.txt", "rt");
	while (!feof(thetests))
	{
		bool opt=false;
		int console;
		int consolelen;
#define CONSOLE_NEEDSILENCE 0
#define CONSOLE_NEEDOUTPUT 1
#define CONSOLE_IGNORE 2

#define CONSOLE_COUNT 1024
#define CONSOLE_LINES 1
#define CONSOLE_ATLEAST 2
#define CONSOLE_EXACTLEN CONSOLE_COUNT
#define CONSOLE_EXACTLINES CONSOLE_COUNT|CONSOLE_LINES
#define CONSOLE_MINLEN CONSOLE_COUNT|CONSOLE_ATLEAST
#define CONSOLE_MINLINES CONSOLE_COUNT|CONSOLE_LINES|CONSOLE_ATLEAST
		//char consolesubstr[4][32];
		//int numconsolesubstr;
		fclose(fopen("thistest.smc", "wt"));//clear the file
		FILE * thistest=fopen("thistest.asm", "wt");
		char thisline[8192];
		char testname[256];
		char binary[32768];
		bool ignorebinary=false;
		memset(binary, 0, 32768);
		fgets(thisline, 8000, thetests);
		if (strchr(thisline, '\n')) *strchr(thisline, '\n')=0;
		bool cont=true;
		while (stricmp(thisline, "---") && cont)
		{
#define strstart(str1, str2) !strncmp(str1, str2, strlen(str2))
			if (strstart(thisline, "Name: ")) strcpy(testname, thisline+6);
			else if (!strcmp(thisline, "Optional: true")) opt=true;
			else if (!strcmp(thisline, "Console: blank")) console=CONSOLE_NEEDSILENCE;
			else if (!strcmp(thisline, "Console: unblank")) console=CONSOLE_NEEDOUTPUT;
			else if (!strcmp(thisline, "Console: ignore")) console=CONSOLE_IGNORE;
			else if (strstart(thisline, "Console: "))
			{
				char * ptr=thisline+9;
				console=CONSOLE_COUNT;
				if (thisline[9]=='>')
				{
					ptr++;
					console|=CONSOLE_ATLEAST;
				}
				consolelen=strtol(ptr, &ptr, 10);
				if (*ptr=='L')
				{
					console|=CONSOLE_LINES;
					ptr++;
				}
			}
			else if (strstart(thisline, "Extern: "))
			{
				char * space=strchr(thisline+8, ' ');
				*space=0;
				FILE * theextern=fopen(thisline+8, "wt");
				fputs(space+1, theextern);
				fclose(theextern);
			}
			else if (strstart(thisline, "Binary: "))
			{
				if (!stricmp(thisline, "Binary: ignore")) ignorebinary=true;
				else
				{
					int binarylen=strlen(thisline+7)/3;
					char * thisbin=thisline+8;
					for (int i=0;i<binarylen;i++)
					{
						binary[i]=(chrfromhex(thisbin[0])<<4)|chrfromhex(thisbin[1]);
						thisbin+=3;
					}
				}
			}
			else fprintf(thistest, "%s\n", thisline);
			cont=fgets(thisline, 8000, thetests);
			if (strchr(thisline, '\n')) *strchr(thisline, '\n')=0;
		}
		fclose(thistest);
		const char * fail=NULL;
		char asdf[256];
		sprintf(asdf, "xkastest-core.exe %s>xkasout.txt", argv[1]);
		int rval=system(asdf);
		if (!ignorebinary)
		{
			FILE * thebinary=fopen("thistest.smc", "rb");
			fseek(thebinary, 0, SEEK_END);
			int binarylen=ftell(thebinary);
			fseek(thebinary, 0, SEEK_SET);
			char therom[32768];
			memset(therom, 0, 32768);
			fread(therom, 1, binarylen, thebinary);
			if (memcmp(therom, binary, 32768))
			{
				char expectedhex[32768];
				char actualhex[32768];
				strcpy(expectedhex, "(blank)");
				strcpy(actualhex, "(blank)");
				int i;
				int hexpos=0;
				for (i=32768;i && binary[i-1]==0;i--);
				for (int j=0;j<i;j++) hexpos+=sprintf(expectedhex+hexpos, "%.2X ", (unsigned char)binary[j]);
				expectedhex[hexpos-1]=0;
				hexpos=0;
				for (i=32768;i && therom[i-1]==0;i--);
				for (int j=0;j<i;j++) hexpos+=sprintf(actualhex+hexpos, "%.2X ", (unsigned char)therom[j]);
				actualhex[hexpos-1]=0;
				errorf("Binary contains unexpected data (expected %s, got %s)", expectedhex, actualhex);
//static bool a=false;if(a)printf("%s",fail);while(a);a=true;
			}
			//else error("Binary has unexpected length");
			fclose(thebinary);
		}
		if (rval==PROGRAM_NO_OUTPUT && console==CONSOLE_NEEDOUTPUT) error("xkas remained silent");
		if (rval==PROGRAM_GAVE_OUTPUT && console==CONSOLE_NEEDSILENCE)
		{
			FILE * xkasout=fopen("xkasout.txt", "rt");
			char temp[1025];
			int xkaslen=fread(temp, 1, 1024, xkasout);
			temp[xkaslen]=0;
			if (strchr(temp, '\n')) *strchr(temp, '\n')=0;
			fclose(xkasout);
			errorf("xkas gave output: %s", temp);
		}
		if (console&CONSOLE_COUNT)
		{
			FILE * xkasout=fopen("xkasout.txt", "rt");
			char temp[1025];
			int xkaslen=fread(temp, 1, 1024, xkasout);
			if (console&CONSOLE_LINES)
			{
				if (temp[xkaslen-1]=='\n') temp[xkaslen-1]=0;
				temp[xkaslen]=0;
				xkaslen=(bool)xkaslen;
				for (int i=0;temp[i];i++) if (temp[i]=='\n') xkaslen++;
			}
			if ((console&CONSOLE_ATLEAST) && xkaslen<=consolelen)
				errorf("xkas gave too short output (expected at least %i %s, got %i)", consolelen+1, (console&CONSOLE_LINES)?"lines":"bytes", xkaslen);
			if (!(console&CONSOLE_ATLEAST) && xkaslen!=consolelen)
				errorf("xkas gave bad output (expected %i %s%s, got %i)", consolelen, (console&CONSOLE_LINES)?"line":"byte", (consolelen==1)?"":"s", xkaslen);
			fclose(xkasout);
		}
		if (rval==PROGRAM_CRASHED) error("xkas crashed");
		if (rval==PROGRAM_TIMED_OUT) error("Patching timed out (infinite loop?)");
//if(!fail)fail="-------------------------";
		if (fail)
		{
			printf("%sest \"%s\" failed: %s\n", opt?"Optional t":"T", testname, fail);
			if (opt) failedopt++;
			else failed++;
//system("pause");
		}
		else printf("%sest \"%s\" passed\n", opt?"Optional t":"T", testname);
		if (opt) totalopt++;
		else total++;
	}
	//unlink("thistest.asm");
	//unlink("thistest.smc");
	//unlink("xkasout.txt");
	printf("Failed %i of %i tests, and %i of %i optional tests.\nYour assembler is%s standards complaint.\n",
					failed, total, failedopt, totalopt, failed?" not":"");
}
